program calcTreeArray;
{
      11 
 ..   .. .
  6.
   14. .   .
                      .
   PascalABC.NET.
}

type
  TTree = record
    data: array of string;
    size: integer;
  end;

function Priority(op:char): integer;
begin
  case op of
    '+','-': Priority:=1;
    '*','/': Priority:=2;
    else Priority:=100;
  end;
end;

function LastOp(s: string): integer;
var i, minPrt: integer;
begin
  minPrt:=50;
  LastOp := 0;
  for i:=1 to Length(s) do
    if Priority(s[i]) <= minPrt then begin
      minPrt:=Priority(s[i]);
      LastOp := i;
    end;
end;

procedure ShowTree(T: TTree);
var i: integer;
begin
  for i:=0 to T.size-1 do
    writeln(i+1,': ',T.data[i], ' ');
end;

procedure AddToTree(s: string; var T: TTree; k: integer);
begin
  if k > High(T.data)+1 then
    SetLength(T.data, High(T.data)+11);
  T.data[k-1]:= s;
  if k > T.size then T.size := k;
end;

procedure Tree(s: string; var T: TTree; iRoot: integer);
var k: integer;
begin
   k:= LastOp(s);
   if k = 0 then AddToTree(s, T, iRoot)
   else begin
     AddToTree(s[k], T, iRoot);
     Tree(Copy(s,1,k-1), T, 2*iRoot);
     Tree(Copy(s,k+1,Length(s)-k), T, 2*iRoot+1);
   end;
end;

function Calc(T: TTree; iRoot: integer): integer;
var n1, n2, res: integer;
begin
  if (2*iRoot > T.size) or (T.data[2*iRoot-1] = '') then
    Val(T.data[iRoot-1], Result, res)
  else begin
    n1:=Calc(T, 2*iRoot);
    n2:=Calc(T, 2*iRoot+1);
    case T.data[iRoot-1][1] of
      '+': Calc:=n1+n2;
      '-': Calc:=n1-n2;
      '*': Calc:=n1*n2;
      '/': Calc:=n1 div n2;
      else Calc:=MaxInt;
    end;
  end
end;

var T: TTree;
    s: string;
begin
  writeln ( '    :' );
  readln ( s );
  SetLength(T.data, 0);
  Tree  (s, T, 1 );
  writeln ( '   :' );
  ShowTree ( T );
  writeln ( ': ', Calc(T, 1) );
end.
